import { race_status } from "../../utils/dict";
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        frameStyle: { useTop: true, name: '小组赛管理', leftArrow: true, useBar: false },
        searchInfo: {},
        list: [],
        dialog: { title: '详细信息', show: false, type: '1' },
        info: {},
        form: {},
        statusList: race_status
    },
    // 跳转菜单
    back(e) {
        wx.navigateBack({ delta: 1 })
    },
    // 查看
    toView: async function (e) {
        const that = this;
        const { item } = e.currentTarget.dataset;
        const arr = await app.$get(`/newCourt/api/race/${item._id}`)
        if (arr.errcode == '0') {
            if (arr.data.winner) {
                const user = await app.$get(`/newCourt/api/user/${arr.data.winner}`);
                if (user.errcode == '0' && user.data) { arr.data.winner_name = user.data.name; }
                else {
                    const team = await app.$get(`/newCourt/api/teamApply/${arr.data.winner}`);
                    if (team.errcode == '0' && team.data) { arr.data.winner_name = team.data.applyuser_name + '-' + team.data.teammate_name; }
                }
            }
            that.setData({ info: arr.data });
            that.setData({ dialog: { title: '详细信息', show: true, type: '1' } })
        }
    },
    // 更换场地
    toChange: async function (e) {
        const that = this;
        const { item } = e.currentTarget.dataset;
        wx.showModal({
            title: '提示',
            content: '您是否确定要更换场地吗?',
            async success(res) {
                if (res.confirm) {
                    const arr = await app.$post(`/newCourt/api/race/${item._id}`, { is_change: '1' });
                    if (arr.errcode == '0') {
                        wx.showToast({ title: `更换场地完成`, icon: 'error', duration: 2000 })
                        that.watchLogin()
                    } else {
                        wx.showToast({ title: `${arr.errmsg}`, icon: 'error', duration: 2000 })
                    }
                }
            }
        })

    },
    // 赛事管理
    toScore: async function (e) {
        const that = this;
        const { item } = e.currentTarget.dataset;
        const arr = await app.$get(`/newCourt/api/race/${item._id}`);
        if (arr.errcode == '0') { that.setData({ form: arr.data }) }
        that.setData({ dialog: { title: '赛事管理', show: true, type: '2' } });
    },
    // 选择比赛状态
    statusChange: function (e) {
        const that = this;
        let data = that.data.statusList[e.detail.value];
        if (data) { that.setData({ 'form.status': data.value }) }
    },
    // 提交保存
    onSubmit: async function (e) {
        const that = this;
        const params = e.detail.value;
        const arr = await app.$post(`/newCourt/api/race/${params._id}`, params);
        if (arr.errcode == '0') {
            wx.showToast({ title: `信息维护成功`, icon: 'error', duration: 2000 })
            that.toClose()
        } else {
            wx.showToast({ title: `${arr.errmsg}`, icon: 'error', duration: 2000 })
        }
    },

    // 关闭弹框
    toClose: function () {
        const that = this;
        that.setData({ info: {} })
        that.setData({ form: {} })
        that.setData({ dialog: { title: '详细信息', show: false, type: '1' } })
        that.watchLogin();
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        const that = this;

    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {
        const that = this;
        that.watchLogin()
    },
    watchLogin: function () {
        const that = this;
        let searchInfo = that.data.searchInfo;
        wx.getStorage({
            key: 'user',
            success: async (res) => {
                let info = { skip: 0, limit: 1000, referee_id: res.data.openid, status: '2' };
                // if (searchInfo && searchInfo.name) info.name = searchInfo.name;
                const arr = await app.$get(`/newCourt/api/race`, { ...info });
                if (arr.errcode == '0') {
                    that.setData({ list: arr.data })
                } else { wx.showToast({ title: `${res.errMsg}`, icon: 'fail', duration: 2000 }); }
            },
            fail: async (res) => {
                wx.redirectTo({ url: '/pages/index/index' });
            },
        });
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})